{Este programa controla uma rede de terminais RS-485 com comutadora paralela,
atravs da Dll Wtechlpt.dll. Sistemas Operacionais Win2000 e XP ou superior,
no permitem acesso direto a porta paralela, para estes S.O. deve-se instalar
o Driver port95nt, sendo que para funcione de forma correta, deve-se estar Logado
como "Administrador" e com "Senha".}

unit uTerminaisParalela;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Grids, ComCtrls;

type
  TfmTerminaisLPT = class(TForm)
    btInicia: TButton;
    btFechar: TButton;
    edPorta: TEdit;
    edTimeOut: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    tmParalela: TTimer;
    sgBD: TStringGrid;
    tmAtualiza_Display: TTimer;
    procedure btFecharClick(Sender: TObject);
    procedure btIniciaClick(Sender: TObject);
    procedure tmParalelaTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tmAtualiza_DisplayTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  const  NTerminal = 32; //nmero de terminais na rede

var
  fmTerminaisLPT: TfmTerminaisLPT;

  flag_iniciou: boolean;
//  terminal:integer; //terminal corrente
  x,k:integer; //utilizados com terminal configurado como flag de serial ativado
  Status:Byte; //status do terminal

  teclado:array[0..NTerminal-1] of string; //buffer de teclado
  waitkbd:array[0..NTerminal-1] of boolean; //flag de espera de digitacao
  pikture:array[0..NTerminal-1] of string; //picture esperada
  pospic :array[0..NTerminal-1] of integer; //posicao dentro da picture que devemos receber
  estado :array[0..NTerminal-1] of integer; //estado de execucao do programa
  Proximo_estado :array[0..NTerminal-1] of integer; //estado de execucao do programa
  balanca: array[0..NTerminal-1] of integer; //contador para pedido de peso de balana
  pprinter:array[0..NTerminal-1] of string; //buffer de impressora paralela
  sprinter:array[0..NTerminal-1] of string; //buffer de impressora serial
  pinpos:array[0..NTerminal-1] of integer; //posicao de entrada do buffer de paralela
  poutpos:array[0..NTerminal-1] of integer; //posicao de saida do buffer de paralela
  sinpos:array[0..NTerminal-1] of integer; //posicao de entrada do buffer de serial
  soutpos:array[0..NTerminal-1] of integer; //posicao de saida do buffer de serial
  Delai:array[0..NTerminal-1] of byte;  // delai exibe msg e volta o estado
  Flag_Serial: array[0..NTerminal-1] of char;
  pFlag_Serial: array[0..NTerminal-1] of byte;
 carac1,carac2:byte;
  //variveis da aplicao
  Usuario:array[0..NTerminal-1] of string;

  Comanda:array[0..NTerminal-1] of string;
  produto:array[0..NTerminal-1] of String;
  quantidade:array[0..NTerminal-1] of string;
  nItens: array[0..NTerminal-1] of byte;
  Ind_Produto:array[0..NTerminal-1] of Integer;
  sPedido:array[0..Nterminal-1] of string;

  //declarao das funes contidas na Dll Wtechlpt.dll
  function ConfigLpt(Endereco, Timeout:Word):Boolean; stdcall; external 'WTechLpt.dll';
  procedure Dll_Close (); stdcall; external 'WTechLpt.dll';
  procedure Dll_PosCur (Terminal, Lin, Col: Byte); stdcall; external 'WTechLpt.dll';
  procedure Dll_Clear (Terminal:Byte); stdcall; external 'WTechLpt.dll';
  procedure Dll_Echo (Terminal:Byte;Dado:char); stdcall; external 'WTechLpt.dll';
  procedure Dll_Display (Terminal:Byte; Dado:string); stdcall; external 'WTechLpt.dll';
  function Dll_Get(Terminal:Byte):char; stdcall; external 'WTechLpt.dll';
  function Dll_Status(Terminal:Byte):Byte; stdcall; external 'WTechLpt.dll';
  function Dll_Print(Terminal:Byte;dado:char):Byte; stdcall; external 'WTechLpt.dll';
  function Dll_Serial(Terminal:Byte;dado:char):Byte; stdcall; external 'WTechLpt.dll';
  function Dll_Acesso(Cmd:string):Integer;stdcall;external 'WTechLpt.dll';

implementation

{$R *.DFM}

procedure Gdisplay(Terminal:byte; str:string );
begin
//Escreve a string correspondente no terminal selecionado
     Dll_Display(Terminal,str);
end;

procedure Gecho(Terminal:byte; str:char );
// Escreve o caracter correspondente no terminal selecionado
begin
     Dll_Echo(Terminal,str);
end;

procedure GPosCursor(Terminal:byte; linha:integer; coluna:integer );
//Posiciona o cursor na linha e coluna desejadas
// linha 0 ou 1, coluna 0  39
begin
     Dll_PosCur(Terminal,Linha, coluna);
end;

procedure Gclear(Terminal:byte);
//Limpa o display do terminal
begin
     Dll_Clear(Terminal);
end;

function Gpedetecla(Terminal:byte):char;
//Recebe caracter do buffer

begin
    result:= Dll_Get(Terminal);
    if result <>  #0 then
    begin
            if result = '\' then
            begin
                 pFlag_Serial[Terminal]:= 1;
                 result:=#0;
            end
               else
                   if pFlag_Serial[Terminal] = 1 then
                   begin
                        pFlag_Serial[Terminal]:= 2;
                        Flag_Serial[Terminal]:= result;
                        result:=#0;
                   end
                      else
                          if pFlag_Serial[Terminal] = 2 then
                          begin
                               carac1:= ord(Flag_Serial[Terminal]);
                               carac1:=carac1 and 240;
                               carac2:= ord(result);
                               carac2:=carac2 and 15;
                               result:= chr(carac1 + carac2);
                               pFlag_Serial[Terminal]:=0;
                          end;

    end;

end;


// Funcao de pedido de entrada de dados.
// As pictures validas sao:
//    9 - caracter numerico
//    A - caracter alfabetico
//    X - qualquer caracter
//    * - Senha
//    #3 - ETX do final do protocolo da balana
//    . - posicao decimal ( so em campo numerico )
//    / - separador de campo( so em campo numerico )
procedure Gget(Terminal:byte; str : string );
begin
     if (waitkbd[terminal]=false) then
     begin
          waitkbd[terminal] := true;
          pospic[terminal]  := 1;
          pikture[terminal] := str;
          teclado[terminal] := '';
     end;
end;

procedure Gpedestatus(Terminal:byte);
//Retorna byte de status do microterminal
begin
     Status:=Dll_Status(Terminal);
end;

procedure Ginicia;
//Inicializa funcionamento do microterminal
var
   i:integer;
begin
     //Configura porta e timeOut
   if  ConfigLpt(StrToInt('$' + fmTerminaisLPT.edPorta.Text) ,StrToInt(fmTerminaisLPT.edTimeOut.Text)) then
   begin
           for i:=0 to NTerminal -1 do
           begin
               pFlag_Serial[i]:=0;
               estado[i]:=0;
               pikture[i]:='';
               pospic[i]:=1;
               waitkbd[i]:=false;
               pinpos[i]:=1;
               pprinter[i]:='';
               poutpos[i]:=1;
               sprinter[i]:='';
               sinpos[i]:=1;
               soutpos[i]:=1;
               Gclear(i);
               Gclear(i);
           end;
           flag_iniciou:= true;
           k:=1;
   end
        else
                ShowMessage('Wtechlpt.dll retornou false'#13'Veja configurao de arquivo INI'#13'Caso comutadora paralela teste funcionamento!');
end;

procedure gAjustaPonto(Terminal:byte);
//Testa se a tecla ponto foi pressionada
var
   PosPonto:integer;
   StrDisp:string;
   spPic:integer;
begin
   PosPonto:=1;
   while (copy(Pikture[terminal], PosPonto, 1) <> '.') do
   begin
        PosPonto := PosPonto + 1;
        if PosPonto >= length(Pikture[terminal]) then
        begin
           Exit;
        end;
   end;
   if PosPonto >= length(Pikture[terminal]) then
   begin
        exit;
   end;
   spPic := PosPonto - 1 - length(Teclado[terminal]);
   StrDisp:='';
   while spPic > 0 do
   begin
        StrDisp := StrDisp + ' ';
        spPic:=spPic - 1;
   end;
   strdisp := strdisp + Teclado[terminal];
   sppic := PosPic[terminal];
   While sppic > 1 do
   begin
        Gecho (Terminal,chr(8));
        sppic := sppic - 1;
   end;
   PosPic[terminal] := posponto;
   Gdisplay (Terminal,strdisp);
   Teclado[terminal] := strdisp;
end;


// Funcao de tratamento do teclado do terminal.
// Pede tecla e faz a consistencia com a picture
// solicitada na funcao GGET, aceitando ou rejeitando
// o que for digitado no terminal.
// Tambem faz o tratamento do // DEL//  do terminal,
// limpando o campo quando tem algum caracter digitado
// ou retornando ESC quando nao tinha nada digitado.
// O retorno desta funcao sera:
//          false - quando a picture solicitada no
//                  ultimo gget nao tiver sido digitada.
//          true - quando a picture tiver sido digitada
//                 completamente ou o CR foi digitado antes do final.
function GtrTecla(Terminal:byte):boolean;
//Trata tecla que foi pressionada
var
   gPict  :string;
   stecla : char;
   tamanho:integer;
begin
   if  (WaitKbd[terminal] = false) then
       begin
            result := false;
            exit;
       end;

   stecla:= Gpedetecla(Terminal);
   if  (sTecla = Chr(13)) then //tecla enter
       begin
            WaitKbd[terminal] := false;
            result := true;
            exit;
       end;
   if sTecla = Chr(127) then //tecla Del
      begin
         if PosPic[terminal] = 1 then
         begin
                 Teclado[Terminal]:= STecla;
                 WaitKbd[terminal] := false;
                 result:= true;
         end
         else
             begin
                  while pospic[terminal] > 1 do
                  begin
                        Gecho(Terminal, chr(8) );
                        pospic[terminal]:=pospic[terminal]-1;
                  end;
                  Teclado[terminal] :='';
                  result:=false;
             end;
         exit;
      end;

   if sTecla=Chr(0) then
      begin
           result := false;
           exit;
      end;
   if sTecla = Chr(8) then //tecla backspace
   begin
          if PosPic[terminal] > 1 then
          begin
               gpict := copy (Pikture[terminal], pospic[terminal] - 1, 1);
               if (gpict = '/') or (gpict = '.') then
                  begin
                     pospic[terminal] := pospic[terminal] - 1;
                     Gecho(Terminal, chr(8) );
                  end;
               pospic [terminal] := pospic[terminal] - 1;
               Teclado[terminal] := copy (Teclado[terminal], 1, pospic[terminal] - 1);
               Gecho(Terminal,chr(8));
          end;
          result := false;
          exit;
   end;

   gpict := copy (Pikture[terminal], pospic[terminal], 1);

   if gpict = #3 then
   begin
         if STecla = #3 then // todo peso foi recebido
         begin
                  waitkbd[terminal] := false;
                  result := true;
                  exit;
         end
         else
              begin
                      if (sTecla<>#2)and (sTecla<>#3) then
                      Teclado[terminal] := Teclado[terminal] + sTecla;
              end;

   end;

   if gpict = 'X' then //qualquer tecla
      begin
         Teclado[terminal] := Teclado[terminal] + sTecla;
         pospic [terminal] := pospic [terminal] + 1;
         gEcho (Terminal,stecla);
      end
   else if gpict = '9' then // Somente aceitar numeros e "." ou "/" ou "-"
        begin
             if ((sTecla >= '0') and (sTecla <= '9')) or (sTecla = '.')
                         or (sTecla = '/')or (sTecla = '-') then
                begin
                     if sTecla = '.' then
                     begin
                          gAjustaPonto (Terminal);
                     end
                else
                    begin
                          Teclado[terminal] := Teclado[terminal] + sTecla;
                          pospic [terminal] := pospic [terminal] + 1;
                          gEcho(Terminal,stecla);
                    end;
                end;
        end
   else if gpict = 'A' then // Alfabetico
        begin
             if (sTecla >= 'A') and (sTecla <= 'Z') then
                begin
                     Teclado[terminal] := Teclado[terminal] + sTecla;
                     pospic [terminal] := pospic [terminal] + 1;
                     gEcho(Terminal,stecla);
                end;
             end
   else if gpict = '*' then // Senha
      begin
             If sTecla in['0'..'9'] Then // caso apenas nmero
             begin
                     Teclado[terminal] := Teclado[terminal] + sTecla;
                     pospic [terminal] := pospic [terminal] + 1;
                     gEcho (Terminal,'*');
             end;
      end
   else begin
      result := false;
      exit;
   end;

   tamanho := length(Pikture[terminal]) + 1;
   gpict   := copy (Pikture[terminal], pospic[terminal], 1);
   if tamanho = pospic[terminal] then
   begin
      waitkbd[terminal] := false;
      result := true;
   end
   else if gpict = '/' then
   begin
      sTecla := '/';
      pospic[terminal] := pospic[terminal] + 1;
      gEcho  (Terminal,stecla);
      result := false;
   end
   else if gpict = '.' then
   begin
      sTecla := '.';
      pospic[terminal] := pospic[terminal] + 1;
      gEcho  (Terminal,stecla);
      result := false;
   end
   else begin
      result := false;
   end;

end;

procedure GPrintp(term:integer; dados:string);
begin
    pinpos[term] := pinpos[term] + length(dados);
    pprinter[term] := pprinter[term] + dados;
end;

procedure GPrints(term:integer; dados:string);
begin
    sinpos[term] := sinpos[term] + length(dados);
    sprinter[term] := sprinter[term] + dados;
end;

//Funo que verifica se o terminal corrente tem algum dado a ser impresso
//na porta paralela
procedure GFlushPrn(Terminal:byte);
var
  Aux:string;
  NBytes_Envio:byte;  // Numero de bytes a ser enviando para a serial a cada passada
  Falha_Envio:integer; // Contador de falha de envio
begin
  if (pinpos[terminal] <> poutpos[terminal]) then //se h dados a serem impressos
  begin
      NBytes_Envio:=0;
      Falha_Envio:= 0;      // a cada passada envia 30 bytes por terminal
      while (NBytes_Envio < 30) and (pinpos[terminal] <> poutpos[terminal]) do
      begin
        //  Aux := copy (pprinter[terminal], poutpos[terminal], 1);
      //    Aux := pprinter[poutpos[terminal]][1];
          Aux := pprinter[Terminal][poutpos[terminal]];
          if Dll_Print(terminal,Aux[1]) <> 0 then //se conseguiu escrever o byte, avana
          begin
            poutpos[terminal]:=poutpos[terminal]+1;
            Falha_Envio:=0;
            inc(NBytes_Envio);
          end else
            inc(Falha_Envio);

          if Falha_Envio >= 50 then  // se no conseguiu escrever por 50 vezes
          begin
            NBytes_Envio:=30;
          end;
      end; // end do while
  end
    else begin
      pprinter[terminal] := '';
      pinpos[terminal] := 1;
      poutpos[terminal] := 1;
    end;
end;





//Funo que verifica se o terminal corrente tem algum dado a ser impresso
//na porta serial
procedure GFlushCom(Terminal:byte);
var
  Aux:string;
  NBytes_Envio:byte;  // Numero de bytes a ser enviando para a serial a cada passada
  Falha_Envio:integer; // Contador de falha de envio
begin
  if (sinpos[terminal] <> soutpos[terminal]) then //se h dados a serem impressos
  begin
      NBytes_Envio:=0;
      Falha_Envio:= 0;      // a cada passada envia 30 bytes por terminal
      while (NBytes_Envio < 30) and (sinpos[terminal] <> soutpos[terminal]) do
      begin
          Aux := copy (sprinter[terminal], soutpos[terminal], 1);
          if Dll_Serial(terminal,Aux[1]) <> 0 then //se conseguiu escrever o byte, avana
          begin
            soutpos[terminal]:=soutpos[terminal]+1;
            Falha_Envio:=0;
            inc(NBytes_Envio);
          end else
            inc(Falha_Envio);

          if Falha_Envio >= 50 then  // se no conseguiu escrever por 50 vezes
          begin
            NBytes_Envio:=30;
          end;
      end; // end do while
  end
    else begin
      sprinter[terminal] := '';
      sinpos[terminal] := 1;
      soutpos[terminal] := 1;
    end;
end;


function Pesquisa(Codigo:String):integer;
var i:byte;
begin
        result := -1;
        i:= 1;
        while i < fmTerminaisLPT.sgBD.RowCount do
        begin
              if fmTerminaisLPT.sgBD.Cells[0,i] = Codigo then
              begin
                     result:= i;
                     break;
              end;
              inc(i);
        end;

end;


procedure TfmTerminaisLPT.btFecharClick(Sender: TObject);
var i:integer;
begin
      tmParalela.Enabled:= False;
      if flag_iniciou then //se passou pelo ConfigLpt()
      begin
            for i:=0 to NTerminal-1 do
            begin
                  Gclear(i);
                  Gdisplay(i,'Sistema Desativado!');
            end;
      end;
      Application.Terminate;
end;

procedure TfmTerminaisLPT.btIniciaClick(Sender: TObject);

begin
     if btInicia.Caption = 'Inicia' then
     begin
             Ginicia();
                         // Se liberar o programa ele enviar dados para os terminais
                         // Se estiver utilizando terminal TCP-IP eles podem no estar
                         // conectado e iro perder o menu inicial.
             tmParalela.enabled:=true;//Inicia Timer (Incio do Programa)
             btInicia.Caption := 'Para';
     end
        else
            begin
                 tmParalela.enabled:=false;//Finaliza Timer (Fim Programa)
                 btInicia.Caption := 'Inicia';
            end;

end;

procedure TfmTerminaisLPT.tmParalelaTimer(Sender: TObject);
//Imprime no display o dado requerido de acordo com o estado do terminal
//correspondente.
var
   Terminal:integer;
begin

tmParalela.Enabled:=false;

     for Terminal:=0 to NTerminal - 1 do
     begin
          GFlushCom(Terminal); //chama o descarregador de impresso serial
          GFlushPrn(Terminal); //chama o descarregador de impresso paralela

          case estado[Terminal] of // Envia dados para o display do terminal
               0:begin             // muda o estado do terminal para pegar o retorno

                         GClear(Terminal);
                         Gdisplay(Terminal,'Usuario:');
                        // Gget(Terminal, '9999' );           //  apenas numeros
                       //  Gget(Terminal, 'AAAAAAAAAAAAA' ); //   apenas alfa
                         Gget(Terminal, 'XXXXXXXXXXXXXXXX' );  // QUALQUER VALOR (ALFA, NUMEROS, TECLAS ESPECIAIS)
                         estado[Terminal]:=1;
               end;

               1:begin                             // Pega retorno do estado 0
                                                  // GtrTecla() Ser True somente quando a mascara de entrada se completar  ou teclar ENTER
                                                  // Exemplo gGet(Terminal,'9999'): Usurio digitando '1','2','3' e '4'
                      If GtrTecla(Terminal) Then  // Quando Teclado[terminal] for igual '123' ser false... quando presionar '4' retorna true e fianliza a mascara
                      begin
                            If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then // Se teclar ENTERou DEL volta estado
                                estado[Terminal] := 0                                      // eficiente para montar novamente a tela quando o equipamento for desligado
                            else
                                begin
                                        estado[Terminal] := 2;
                                        Usuario[terminal]:= teclado[terminal];
                                end;

                      end;

               end;


               2: begin   // Envia dados para o display do terminal e muda o estado para pegar o retorno
                         GClear(Terminal);
                         Gdisplay(Terminal,'Senha:');
                         Gget(Terminal, '****' ); // Mascara para ecoar '*'
                         estado[Terminal]:=3;
               end;

               3:begin
                      If GtrTecla(Terminal) Then // Ser true quando digitar os 4 digitos da mascara, ou teclar ENTER
                      begin
                            If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then // Teclou ENTER ou DEL mas no digitou
                                estado[Terminal] := 0                                      // volta estado
                            else
                                If Teclado[Terminal] = '1234' Then // verifica a senha se correta
                                estado[Terminal] := 4              // if Valida_Usuario( usuario[terminal], Teclado[Terminal] )
                                else                               // usuario pegamos no estado 0 e 1. Teclado est valendo a senha
                                     begin
                                            GClear(Terminal);
                                            Gdisplay (Terminal,'Senha Invalida!');
                                            GPosCursor(terminal,1,2);
                                            Gdisplay(terminal,'Aceita "1234"'); // No exemplo aceita apenas '1234'
                                            estado[Terminal] := 99; // Estado morto para prender aplicao exibindo msg para o usurio
                                            Proximo_estado[terminal]:=2; // para qual estado pretendemos enviar.
                                                                        //  IMPORTANTE: Deve ser enviando para estando onde gGet()  chamado, que no nosso so os estados PARES.
                                            GGet(Terminal,'X');  // permite que pressione qualquer tecla.
                                     end;
                      end;
               end;

               4: begin
                         sPedido[terminal]:=''; // envia dados para o display do terminal e muda o estado para pegar o retorno.
                         GClear(Terminal);         // neste ponto j deve ter observado que no estado PAR enviamos dados para o terminal
                         Gdisplay(Terminal,'Comanda:');  // e no estado IMPAR pegamos o retorno.
                         Gget(Terminal,'9999' );
                         estado[Terminal]:=5;
                         nItens[Terminal]:=0;
               end;

               5: begin
                        if GtrTecla(Terminal) then
                        begin
                               If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then
                               estado[Terminal]:= 0
                               else
                                   begin                          // Apenas para exibir no programa os dados
                                         estado[Terminal]:=6;     // coletados, vamos aproveitar para enviar para impressora
                                         Comanda[Terminal]:=teclado[Terminal];
                                         sPedido[Terminal]:= '<<< Comanda  ' + comanda[Terminal] + ' >>>'#13#10;
                                         sPedido[Terminal]:= sPedido[Terminal] + 'Usuario: ' + Usuario[Terminal] + #13#10;
                                         sPedido[Terminal]:= sPedido[Terminal] +'Items: -----------------------------'#13#10;
                                   end;
                        end;
               end;
                                     
               6: begin
                           GClear(Terminal);
                           Gdisplay(Terminal,'Produto:');
                           Gget(Terminal,'99999999999999');
                           estado[Terminal]:= 7;
                           Delai[terminal]:=0;
               end;

               7: begin
                        if GtrTecla(Terminal) then
                        begin
                               If (nItens[Terminal] =0 ) and (teclado[Terminal] = '') or (teclado[Terminal] = #127) then
                               Estado[Terminal]:= 0  // Se pressionar ENTER ou DEL volta para o inicio. Caso no tenha lanado item
                               else
                                    if (teclado[Terminal] = '') and (nItens[Terminal]<> 0 )  then
                                    begin
                                        estado[Terminal]:=12; // Em Produto: se pressionar ENTER sem digitar nada fecha o pedido
                                    end                      // talvez seja interessante confirmar o fechamento em outro estado.
                                    else
                                    begin
                                            Ind_Produto[terminal]:= Pesquisa(teclado[Terminal]); // faz a pesquisa do cdigo, no exemplo est psquisando o Grid
                                            if  Ind_Produto[terminal] = -1  then // no encontrou
                                            begin
                                                      GClear(Terminal);
                                                      Gdisplay (Terminal,'Produto nao');
                                                      GPosCursor(terminal,1,2);
                                                      Gdisplay(terminal,'Localizado!');
                                                      estado[Terminal] := 99;
                                                      Proximo_estado[terminal]:=6;
                                                      GGet(Terminal,'X');
                                            end
                                                else
                                                    begin
                                                          if sgBD.Cells[4,Ind_Produto[terminal]] = 'KG' then // produto por peso
                                                          estado[Terminal]:= 10
                                                          else    // produto por quantidade
                                                              estado[Terminal]:=8;
                                                          produto[Terminal]:=sgBD.cells[1,Ind_Produto[terminal]];
                                                    end;
                                    end;
                        end;
               end;

               8: begin
                           GClear(terminal);
                           GDIsplay(Terminal,'Quantidade:');
                           GGet(Terminal,'XXXXX');
                           estado[Terminal] := 9;
               end;

               9: begin
                        if GtrTecla(Terminal) then
                        begin

                                 if (teclado[Terminal] = #127) Then
                                 estado[Terminal]:= 6   // Volta para produto
                                 else

                                 If (teclado[Terminal] = '') then
                                 begin
                                       estado[Terminal]:= 8; //Pressionou ENTER sem digitar
                                 end
                                 else
                                      begin  // houve digitao
                                              inc(nItens[terminal]);
                                              quantidade[Terminal]:=teclado[Terminal];
                                              GClear(Terminal);
                                              Gdisplay (Terminal,'Produto:' + produto[Terminal]);
                                              GPosCursor(Terminal,1, 0);
                                              Gdisplay (Terminal,'Quantidade:' + quantidade[Terminal]);
                                              sPedido[Terminal] := sPedido[Terminal] + IntToStr(Nitens[Terminal])  + ') ' + Quantidade[Terminal] + ' - ' + produto[Terminal] + #13#10;
                                              GGet(Terminal,'X');
                                              estado[Terminal]:=99;      // note que no programa h dois timers, neste ponto alm de poder teclar para voltar
                                              proximo_estado[terminal]:=6;  // ser exibido a msg e o segundo timer que se encarregar de voltar.
                                              Delai[terminal]:=4;           // quando delai for 0, o estado mudar para 12.
                                      end;
                        end;
               end;

               10: begin
                           GClear(Terminal);
                           GDisplay(Terminal,'Aguardando Peso...');
                           GPrintS(Terminal,chr(5)); // normalmente 05h  reconhecido pela balana como solicitao de peso
                           GGet(Terminal,#3);        // dependendo do protocolo da balana poderia montar a mascara no seguinte formato:
                           estado[Terminal]:=11;    // Protocolo simples STX PPPPP ETX mascara 'X99999X'
                           balanca[terminal]:= 0;   // Protocolo longo STX S PPPPP B VVVVV B TTTTT ETX mascara 'XX99999X99999X99999X'
               end;                                 // Em ambos casos o pacote termina com ETX (03h). Neste caso como no sei o tamanho do paconte
                                                    // contendo o peso, chamo gGet(terminal,#3). Assimn quando receber o fim do pacote GtrTecla(0 ser true

               11: begin
                            inc(balanca[Terminal]);      // varivel balana controla a solicitao em caso de falha na comunicao
                            if GtrTecla(Terminal) then
                            begin
                                 If (teclado[Terminal] = '') or (teclado[Terminal] = #127) Then
                                 begin    //Peso no chegou, pressionou enter para digitar aquantidade
                                       estado[Terminal]:= 8;
                                 end                                        
                                       else
                                             begin
                                                    inc(nItens[terminal]);
                                                    quantidade[Terminal]:=teclado[Terminal];
                                                    GClear(Terminal);
                                                    Gdisplay (Terminal,'Produto:' + produto[Terminal]);
                                                    GPosCursor(Terminal,1, 0);
                                                    Gdisplay (Terminal,'Quantidade:' + quantidade[Terminal]);
                                                    sPedido[Terminal]:= IntTostr( Nitens[Terminal]) + ') ' + Quantidade[Terminal] + ' - ' + produto[Terminal]+ #13#10;
                                                    estado[Terminal]:=99;
                                                    Gget(Terminal,'X');
                                                    proximo_estado[terminal]:=6;
                                                    Delai[terminal]:=4; // Exibe alguns segundo a msg no display e volta para 12
                                             end;
                            end
                               else
                                    if Balanca[terminal] = 250 then // ficou esperando pelo peso. No recebendo volta o estado e pede novamente
                                    Estado[terminal]:=10;           // Valor 250 deve ser ajustavel, deve ter relao com o timer, neste exemplo o
                                                                    // o timer est com 10 ms
               end;


               12:begin
                         {
                           IMPORTANTE: Para evitar problemas de se enviar dados para a Paralela
                           de um terminal sem ter impressora ligada a ela, a rotina que descarrega
                           o buffer de impressora est comentada. Caso necessite imprimir use GflushCOM ou GFlushPrn

                           // Envia para a paralela do terminal. Sendo terminal 16 teclas, veja se existe LPT.
                           GPrintp(Terminal,sPedido[Terminal] + #13#10);
                           GFlushprn(Terminal);

                           // Envia para a serial do terminal.
                           GPrints(Terminal,sPedido[Terminal] + #13#10);
                           GFlushcom(Terminal);

                         }

                        GClear(Terminal);
                        Gdisplay (Terminal,'Pedido: ' + Comanda[Terminal]);
                        GPosCursor(Terminal,1,0);
                        Gdisplay (Terminal,'Fechando...');
                        Estado[Terminal]:=99;
                        gGet(Terminal,'X');
                        Delai[Terminal]:=4;
                        Proximo_estado[Terminal]:=0;
               end;


               99: if GtrTecla(Terminal) then
                   begin
                       estado[Terminal]:=proximo_estado[terminal];
                       Delai[Terminal]:=0;
                   end;

          end;
     end;
     tmParalela.Enabled:=true;
end;

procedure TfmTerminaisLPT.FormCreate(Sender: TObject);
var Arq:TextFile;
i,j:integer;
Dados,tmp:string;
begin

        sgBD.Cells[0,0]:= 'Codigo';
        sgBD.Cells[1,0]:= 'Desc';
        sgBD.Cells[2,0]:= 'Preo';
        sgBD.Cells[3,0]:= 'Qtde';
        sgBD.Cells[4,0]:= 'Unidade';



        if FileExists(GetCurrentDir + '\Produtos.txt') then
        begin
                AssignFile(Arq ,GetCurrentDir + '\Produtos.txt');
                reset(Arq);
                j:=1;
                tmp:='';
                while not Eof(Arq) do
                begin
                      sgBD.RowCount:= j + 1;
                      readln(arq,Dados);

                      i:=0;
                      while Dados  <> '' do
                      begin
                                if dados[1] = ';' then
                                begin
                                    //    delete(dados,1,1);
                                        sgBD.Cells[i,j]:= tmp;
                                        tmp:='';
                                        inc(i);
                                end
                                   else
                                         tmp:=tmp + dados[1];
                                delete(Dados,1,1);
                      end;

                    inc(j);
                end;
                CloseFile(Arq);
        end;
      flag_iniciou:= false;
end;




procedure TfmTerminaisLPT.FormDestroy(Sender: TObject);
begin
   Dll_Close();
end;



// Atualiza o display e volta para o estado asinalado em Proximo_Estado
procedure TfmTerminaisLPT.tmAtualiza_DisplayTimer(Sender: TObject);
var term:byte;
begin
        for term:=0 to NTerminal do // loop verificando se h algun terminal
        if Delai[Term] > 0 then     // com msg no display
        begin
              dec(Delai[term]);
              if delai[term] = 0 then
              begin
                    waitkbd[Term]:= false;
                    estado[term]:= proximo_estado[Term];  // na prxima passado do timer principal
              end;                                        // volta para o estado correto.
        end;                                              // Lembrando que proximo_estado no pode ser IMPAR
end;                                                      // por causa da estrutura. Estado IMPAR espera por tecla
                                                          // E nessa volta de estado nenhuma tecla estar sendo aguardada: Travamento certo!
end.
